/*
 * Copyright 2018 Allanic.me ISC License License
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 * Created by mallanic <maxime@allanic.me> at 14/10/2018
 */

/**
* Copyright 2015 IBM Corp.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
* http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
**/

const $lodash = require('lodash');

module.exports = class Machine {
    constructor (driver, options) {
        this.id = $lodash.uniqueId();
        try {
            this.driver = new (require(__dirname + '/' + driver))(options);
        } catch (e) {
            console.error(e);
            throw new Error(`There is no driver call ${ driver }`);
        }
    }

    create(machineName, options) {
        return this.driver.create(machineName, options);
    }

    rm(machineName) {
        return this.driver.rm(machineName);
    }

    delete(instance) {
        return this.driver.delete(instance);
    }

    list() {
        return this.driver.list();
    }

    getBillAmount() {
        return this.driver.getBillAmount();
    }
};
